Package net.sf.saxon.value

## Class HexBinaryValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.HexBinaryValue

- All Implemented Interfaces:
    `java.lang.Comparable`, `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public class HexBinaryValue
      extends AtomicValue
      implements AtomicMatchKey, java.lang.Comparable

  A value of type xs:hexBinary

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HexBinaryValue​(byte[] value)` | Constructor: create a hexBinary value from a given array of bytes
    `HexBinaryValue​(java.lang.CharSequence in)` | Constructor: create a hexBinary value from a supplied string, in which each octet is represented by a pair of values from 0-9, a-f, A-F
    `HexBinaryValue​(java.lang.CharSequence s, AtomicType type)` | Constructor: create a HexBinary value from a supplied string in hexBinary encoding, with a specified type.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareTo​(java.lang.Object o)` |
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a primitive copy of this atomic value (usually so that the type label can be changed).
    `boolean` | `equals​(java.lang.Object other)` | Test if the two hexBinary or Base64Binaryvalues are equal.
    `byte[]` | `getBinaryValue()` | Get the binary value
    `int` | `getLengthInOctets()` | Get the number of octets in the value
    `java.lang.CharSequence` | `getPrimitiveStringValue()` | Convert to string
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `java.lang.Comparable<net.sf.saxon.value.HexBinaryValue.HexBinaryComparable>` | `getSchemaComparable()` | Support XML Schema comparison semantics
    `AtomicMatchKey` | `getXPathComparable​(boolean ordered, StringCollator collator, int implicitTimezone)` | Get an object value that implements the XPath equality and ordering comparison semantics for this value.
    `int` | `hashCode()` |

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getComponent, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, identityHashCode, isIdentical, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### HexBinaryValue

          public HexBinaryValue​(java.lang.CharSequence in)
                         throws XPathException

      Constructor: create a hexBinary value from a supplied string, in which each octet is represented by a pair of values from 0-9, a-f, A-F
      Parameters:
        `in` - character representation of the hexBinary value
      Throws:
        `XPathException` - if the input is invalid

    - #### HexBinaryValue

          public HexBinaryValue​(java.lang.CharSequence s,
                                AtomicType type)

      Constructor: create a HexBinary value from a supplied string in hexBinary encoding, with a specified type. This method throws no checked exceptions; the caller is expected to ensure that the string is a valid Base64 lexical representation, that it conforms to the specified type, and that the type is indeed a subtype of xs:base64Binary. An unchecked exception such as an IllegalArgumentException may be thrown if these conditions are not satisfied, but this is not guaranteed.
      Parameters:
        `s` - the value in hexBinary encoding, with no leading or trailing whitespace
        `type` - the atomic type. This must be xs:base64binary or a subtype.

    - #### HexBinaryValue

          public HexBinaryValue​(byte[] value)

      Constructor: create a hexBinary value from a given array of bytes
      Parameters:
        `value` - the value as an array of bytes

  - ### Method Detail

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a primitive copy of this atomic value (usually so that the type label can be changed).
      Specified by:
        `copyAsSubType` in class `AtomicValue`
      Parameters:
        `typeLabel` - the target type (a derived type from hexBinary)
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Specified by:
        `getPrimitiveType` in class `AtomicValue`
      Returns:
        the primitive type

    - #### getBinaryValue

          public byte[] getBinaryValue()

      Get the binary value
      Returns:
        the binary value, as a byte array

    - #### getPrimitiveStringValue

          public java.lang.CharSequence getPrimitiveStringValue()

      Convert to string
      Specified by:
        `getPrimitiveStringValue` in class `AtomicValue`
      Returns:
        the canonical representation.

    - #### getLengthInOctets

          public int getLengthInOctets()

      Get the number of octets in the value
      Returns:
        the number of octets (bytes) in the value

    - #### getSchemaComparable

          public java.lang.Comparable<net.sf.saxon.value.HexBinaryValue.HexBinaryComparable> getSchemaComparable()

      Support XML Schema comparison semantics
      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Specified by:
        `getSchemaComparable` in class `AtomicValue`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### getXPathComparable

          public AtomicMatchKey getXPathComparable​(boolean ordered,
                                                   StringCollator collator,
                                                   int implicitTimezone)

      Get an object value that implements the XPath equality and ordering comparison semantics for this value. If the ordered parameter is set to true, the result will be a Comparable and will support a compareTo() method with the semantics of the XPath lt/gt operator, provided that the other operand is also obtained using the getXPathComparable() method. In all cases the result will support equals() and hashCode() methods that support the semantics of the XPath eq operator, again provided that the other operand is also obtained using the getXPathComparable() method. A context argument is supplied for use in cases where the comparison semantics are context-sensitive, for example where they depend on the implicit timezone or the default collation.
      Specified by:
        `getXPathComparable` in class `AtomicValue`
      Parameters:
        `ordered` - true if an ordered comparison is required. In this case the result is null if the type is unordered; in other cases the returned value will be a Comparable.
        `collator` - collation to be used for comparing strings
        `implicitTimezone` - to be used for comparing dates/times with no timezone
      Returns:
        a key used for performing the comparison

    - #### equals

          public boolean equals​(java.lang.Object other)

      Test if the two hexBinary or Base64Binaryvalues are equal.
      Specified by:
        `equals` in class `AtomicValue`
      Parameters:
        `other` - the other value
      Returns:
        true if the other operand is an atomic value and the two values are equal as defined by the XPath eq operator

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### compareTo

          public int compareTo​(java.lang.Object o)

      Specified by:
        `compareTo` in interface `java.lang.Comparable`